<template>
  <div class="game-box" :class="{ flattened: isBoardCleared() }">
    <div class="grid">
      <div v-for="(column, x) in grid.cells" class="grid-column">
        <div v-for="(cell, y) in column"
        class="grid-cell"
        :class="[
          { highlighted: cell.highlighted },
          { flattened: isBoardCleared() || !moves },
        ]"
        v-on:click="cellClicked(cell, x, y)">
          <color-chip
          v-if="cell.colorChip"
          :coordinates="{ x, y }"
          :chip="cell.colorChip">
          </color-chip>
        </div>
      </div>
    </div>
    <div class="game-box-info">
      <p>Moves: {{moves}} / {{maxMoves}}</p>
      <p>Max Up: {{exp}} / {{expGoal}}</p>
      <p>Score: {{score}}</p>
      <p>Level: {{level}}</p>
    </div>
    <input type="button"
    :class="{ highlighted: isBoardCleared() }"
    v-on:click="refreshBoard()"
    :value="isBoardCleared() ? 'Next Level' : 'Reset Level'">
  </div>
</template>

<script lang="ts">
import colorChip from './ColorChip.vue'
import { store } from '../store'
import { Grid } from '../types/Grid'

export default {
  components: {
    colorChip,
  },
  props: {
    grid: Grid,
    moves: Number,
    maxMoves: Number,
    exp: Number,
    expGoal: Number,
    score: Number,
    level: Number,
  },
  setup() {
    return {
      refreshBoard() {
        store.dispatch('refreshBoard');
      },
      isBoardCleared() {
        return store.getters.isBoardCleared;
      },
      cellClicked(cell, x, y) {
        // make sure cell is empty
        if (cell.colorChip) return;
        // handle empty cell clicked
        store.dispatch('emptyCellClicked', {
          emptyCell: cell,
          coordinates: { x, y },
        });
      },
    }
  }
}
</script>

<style lang="scss">
.game-box {
  background: #26282c;
  position: fixed;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  border-radius: 10px;
  padding: 10px;
  box-shadow: 0 10px 10px #0005;
  transition: 0.25s;
  &.flattened {
    box-shadow: 0 0 0 #0005;
    top: calc(50% + 3px);
  }
  .grid {
    display: flex;
    .grid-column {
      display: flex;
      flex-direction: column;
      .grid-cell {
        position: relative;
        background: #0005;
        width: 20px;
        height: 20px;
        margin: 5px;
        border-radius: 50%;
        box-shadow: 0 5px 5px #0005 inset;
        box-sizing: border-box;
        transition-property: background-color, box-shadow;
        transition-duration: 0.25s;
        &.flattened {
          box-shadow: 0 1px 1px #0005 inset;
          background: #0004;
        }
        &.highlighted {
          animation: 1s infinite highlightedCell;
          border: 5px solid #151618;
        }
      }
    }
  }
  .game-box-info {
    padding: 10px 0 0;
    text-align: right;
    p {
      margin: 5px;
    }
  }
  input {
    padding: 10px 50px;
    background: #35383e;
    border: none;
    border-radius: 100px;
    box-shadow: 0 5px 5px #0005;
    position: absolute;
    bottom: 20px;
    left: 20px;
    outline: none;
    transition: 0.25s;
    &:hover {
      background: #46494f;
      transform: translateY(-3px);
      box-shadow: 0 20px 20px #0005;
    }
    &:active {
      transition: 0s;
      transform: translateY(1px);
      background: #35383e;
      box-shadow: none;
    }
    &.highlighted {
      background: #41c588;
      &:hover {
        background: #52dd9d;
      }
    }
  }
}
@keyframes highlightedCell {
  0% {
    background: transparent;
  }
  50% {
    background: #fff5;
  }
  100% {
    background: transparent;
  }
}
</style>
